Subject: [tsv-area] Proto-BOF on transport architecture issues discussed in TSVAREA

From: Bryan Ford <[email-masked]>
Date: Wed, 19 Nov 2008 19:04:14 -0600

Hi folks,

I'd like to follow up on the TSVAREA meeting by suggesting that those  
of us interested in the various and overlapping transport architecture  
that we discussed today - e.g., layering model, UDP encapsulations for  
various transports, congestion control fairness/TCP-friendliness/ 
segmentation/aggregation, etc. - try to meet for an informal "proto- 
BOF" and continue discussing these issues and how we might move  
forward.  For starters, maybe those of us available can meet up just  
outside the main meeting room sometime shortly after the plenary  
that's happening now.  And if you're interested but can't make that  
time (or just don't see this E-mail in time), just E-mail me and I'll  
let you know if/when we find another time slot later, and for the  
longer term we might think about starting a suitable mailing list.

Thanks,
Bryan

---

From: Joe Touch <[email-masked]>
Date: Wed, 19 Nov 2008 17:11:54 -0800

Hi, Bryan,

I'm definitely interested in this, but have post-plenary plans.

Joe

Bryan Ford wrote:
> Hi folks,
> 
> I'd like to follow up on the TSVAREA meeting by suggesting that those of
> us interested in the various and overlapping transport architecture that
> we discussed today - e.g., layering model, UDP encapsulations for
> various transports, congestion control
> fairness/TCP-friendliness/segmentation/aggregation, etc. - try to meet
> for an informal "proto-BOF" and continue discussing these issues and how
> we might move forward.  For starters, maybe those of us available can
> meet up just outside the main meeting room sometime shortly after the
> plenary that's happening now.  And if you're interested but can't make
> that time (or just don't see this E-mail in time), just E-mail me and
> I'll let you know if/when we find another time slot later, and for the

---

From: <[email-masked]>
Date: Thu, 20 Nov 2008 01:19:31 +0000

On 08-11-19 19:04, "Bryan Ford" <[email-masked]> wrote:
> And if you're interested but can't make that

Here are the IESG breakout room (Director's Row 4) reservations for
tomorrow. If you want it during one of the available times, let me know.

Thursday
    1130 - 1300 AAA-DIR (Dan)
    1600 - 1630 (Ross)
    1740 - 1930 NVRG bar BOF (Lars)

Lars

---

From: <[email-masked]>
Date: Thu, 20 Nov 2008 01:21:50 +0000

>     1740 - 1930 NVRG bar BOF (Lars)

Left out:
    2000 - 2200 PPSP bar BOF (Lars)

Lars

---

From: Bryan Ford <[email-masked]>
Date: Wed, 19 Nov 2008 20:30:21 -0600

Quick update: for anyone interested who might have missed hooking up  
after the plenary, we're heading to Chipotle Mexican Grill, 1040  
Nicollett Mall.

> Hi folks,
>
> I'd like to follow up on the TSVAREA meeting by suggesting that  
> those of us interested in the various and overlapping transport  
> architecture that we discussed today - e.g., layering model, UDP  
> encapsulations for various transports, congestion control fairness/ 
> TCP-friendliness/segmentation/aggregation, etc. - try to meet for an  
> informal "proto-BOF" and continue discussing these issues and how we  
> might move forward.  For starters, maybe those of us available can  
> meet up just outside the main meeting room sometime shortly after  
> the plenary that's happening now.  And if you're interested but  
> can't make that time (or just don't see this E-mail in time), just E- 
> mail me and I'll let you know if/when we find another time slot  
> later, and for the longer term we might think about starting a  
> suitable mailing list.
>
> Thanks,
> Bryan
>

---

From: Matt Mathis <[email-masked]>
Date: Wed, 19 Nov 2008 23:26:53 -0500 (EST)

We missed you some how - we hung out for quite a while after the plenary, 
checked for email (there was none) and punted....

Thanks,
--MM--
-------------------------------------------
Matt Mathis     http://staff.psc.edu/mathis
Work:412.268.3319    Home/Cell:412.654.7529
-------------------------------------------
Evil is defined by mortals who think they know
"The Truth" and use force to apply it to others.

On Wed, 19 Nov 2008, Bryan Ford wrote:

> Quick update: for anyone interested who might have missed hooking up after 
> the plenary, we're heading to Chipotle Mexican Grill, 1040 Nicollett Mall.
>
>> Hi folks,
>> 
>> I'd like to follow up on the TSVAREA meeting by suggesting that those of us 
>> interested in the various and overlapping transport architecture that we 
>> discussed today - e.g., layering model, UDP encapsulations for various 
>> transports, congestion control 
>> fairness/TCP-friendliness/segmentation/aggregation, etc. - try to meet for 
>> an informal "proto-BOF" and continue discussing these issues and how we 
>> might move forward.  For starters, maybe those of us available can meet up 
>> just outside the main meeting room sometime shortly after the plenary 
>> that's happening now.  And if you're interested but can't make that time 
>> (or just don't see this E-mail in time), just E-mail me and I'll let you 
>> know if/when we find another time slot later, and for the longer term we 
>> might think about starting a suitable mailing list.
>> 
>> Thanks,
>> Bryan
>

---

From: Scott Brim <[email-masked]>
Date: Wed, 19 Nov 2008 23:23:43 -0600

I'm interested in exploring and understanding the ideas, although I
can't promise any work, alas.  For example, how will concatenated flow
control mechanisms work together?  I think it might be possible for
each to communicate with the next, and represent its basic machinery
(including the model of those beyond it), so that each can take the
others into consideration.  Maybe.  Let me know where you'll meet.

Thanks ... Scott

Excerpts from Bryan Ford on Wed, Nov 19, 2008 07:04:14PM -0600:
> segmentation/aggregation, etc. - try to meet for an informal "proto-BOF" 
> and continue discussing these issues and how we might move forward.  For 
> starters, maybe those of us available can meet up just outside the main 
> meeting room sometime shortly after the plenary that's happening now.  
> And if you're interested but can't make that time (or just don't see this 
> E-mail in time), just E-mail me and I'll let you know if/when we find 
> another time slot later, and for the longer term we might think about 
> starting a suitable mailing list.
>
> Thanks,
> Bryan

---

From: Matt Mathis <[email-masked]>
Date: Thu, 20 Nov 2008 08:27:12 -0500 (EST)

See for example Phoebus:
http://e2epi.internet2.edu/phoebus.html
http://portal.acm.org/citation.cfm?id=1188455.1188714

My understanding (which is the way I would do it as well) is the congestion 
control in the bottlenecked link is reflected in the flow control on the other 
links.  The problem is that you would like to do the flow control end to end, 
which would require that the receiver has a window large enough to carry all 
of the data in flight in all spans plus the data queued at every node.  Part 
of the goal of the I2 phoebus project was to free the end user from getting 
the tuning right, so phoebus announces extra window space on the interior 
spans.  Given that this is also how congestion control information is passed 
span to span, getting it right is probably quite important, but I do not know 
what they do.

Phoebus is not integrated into the TCP protocol as was suggested in the 
presentation.  You had to do something that looked like an explicit proxy 
configuration (akin to using ssh port forwarding).

However the dynamics of the interior of the path would have to be pretty much 
the same.

Thanks,
--MM--

---

From: Bryan Ford <[email-masked]>
Date: Thu, 20 Nov 2008 08:21:08 -0600

For those interested, a second attempt at a transport architecture  
"proto-BOF" meeting will happen today at 9AM, in or just outside of  
the IESG breakout room (Directors Row 4, across from Salon D).

And since it looks impossible to find any one time that suits  
everyone, another round might happen tonight after dinner, 9PM-ish,  
likely over beer.

In any case, once again, E-mail me if you're interested in the topic  
and not already on the list I'm putting together.

Thanks,
Bryan

On Nov 19, 2008, at 8:30 PM, Bryan Ford wrote:
>> TCP-friendliness/segmentation/aggregation, etc. - try to meet for  
>> an informal "proto-BOF" and continue discussing these issues and  
>> how we might move forward.  For starters, maybe those of us  
>> available can meet up just outside the main meeting room sometime  
>> shortly after the plenary that's happening now.  And if you're  
>> interested but can't make that time (or just don't see this E-mail  
>> in time), just E-mail me and I'll let you know if/when we find  
>> another time slot later, and for the longer term we might think  
>> about starting a suitable mailing list.
>>
>> Thanks,
>> Bryan
>>
>

---

From: Janardhan Iyengar <[email-masked]>
Date: Thu, 20 Nov 2008 10:14:12 -0500

Matt,

It is actually very neat to think about turning congestion control into flow control at the segment boundaries. We had originally thought about pushing the same network queue behavior up the stack to the Flow Layer, that is, to propagate delay/loss in the network as delay/loss at the Flow Layer to indicate congestion. But it actually makes a lot more sense to think of turning congestion inside of a segment into per-segment flow control.

I am familiar with Martin Swany's previous work that lead up to Phoebus (the LSL project), do you have any pointers to literature on Phoebus?

Thanks,
- jana

Matt Mathis wrote:
> My understanding (which is the way I would do it as well) is the 
> congestion control in the bottlenecked link is reflected in the flow 
> control on the other links.  The problem is that you would like to do 
> the flow control end to end, which would require that the receiver has a 
> window large enough to carry all of the data in flight in all spans plus 
> the data queued at every node.  Part of the goal of the I2 phoebus 
> project was to free the end user from getting the tuning right, so 
> phoebus announces extra window space on the interior spans.  Given that 
> this is also how congestion control information is passed span to span, 
> getting it right is probably quite important, but I do not know what 
> they do.
> 
> presentation.  You had to do something that looked like an explicit 
> proxy configuration (akin to using ssh port forwarding).
> 
> However the dynamics of the interior of the path would have to be pretty 
> much the same.
> 
> Thanks,
> --MM--

-- 
Janardhan Iyengar
Assistant Professor, Computer Science
Franklin & Marshall College
http://www.fandm.edu/jiyengar

---

From: Bob Briscoe <[email-masked]>
Date: Thu, 20 Nov 2008 18:47:59 +0000

Bryan & all,

Here's stuff or links to stuff I mentioned in this proto-BoF just now:

(necessary & sufficient?) transport functions
• connection life-cycle control (creation, keep-alive, tear-down)
• multiplexing / demultiplexing
• reliable delivery
   – data delivery
   – loss detection and repair
   – duplicate detection
   – same order delivery
• flow control (buffer mgmt, prioritisation)
• framing
• congestion control (incl fairness or differentiation)

* Flexinet [Hayton98] (see BiBTeX at end)
"Interface names are arbitrarily complex objects 
that can be resolved by a protocol stack to 
provide a route from the client to the 
destination interface (or interfaces for replicated objects)."

* Flow layer? layered and concatenated load regulation:
<http://tools.ietf.org/html/draft-ietf-tsvwg-ecn-tunnel-01#appendix-D>

* Shim4 : ask Rob Hancock (cc'd)

@INPROCEEDINGS{Hayton98:Flexinet,
   author = {Richard Hayton and Andrew Herbert and Douglas Donaldson},
   affiliation = {APM},
   year = 1998,
   title = {{FlexiNet} --- {A} flexible component oriented middleware system},
   booktitle = {Proc. SIGOPS'98},
   keywords = {Data Communication, Networks, Internet, Computing, Software
              Engineering, Object-Oriented, Mobility, Multimedia, Quality of
              Service, QoS, Management, Adaptation, Architecture, Middleware,
              Layering, Reflection, Java},
   entryby = {RJB},
   entry = {11 may 1998},
   url = {URL: 
\url{http://www.ansa.co.uk/ANSATech/ANSAhtml/98-ansa/external/9809Conf/9809fnrp.pdf}},
   abstract-url = {URL: 
\url{http://www.ansa.co.uk/ANSATech/ANSAhtml/htmltree/98-primary.html}}
}

Bob

At 14:21 20/11/2008, Bryan Ford wrote:
>____________________________________________________________________________
>Bob Briscoe, <[email-masked]>      Networks Research Centre, BT Research
>B54/77 Adastral Park,Martlesham Heath,Ipswich,IP5 3RE,UK.    +44 1473 645196

---

From: Bryan Ford <[email-masked]>
Date: Thu, 20 Nov 2008 17:01:57 -0600

Just to confirm, a second round of transport architecture evolution  
discussion IS happening tonight around 9PM - let's meet at Brit's Pub,  
1110 Nicollet Ave, about one block from the Hilton:

http://maps.google.com/maps?f=d&saddr=44.972943,-93.273652&daddr=1110+Nicollet+Ave+S,+Minneapolis,+MN+55403&hl=en&geocode=%3BFeY5rgIdKLhw-g&mra=dme&mrcr=0&mrsp=0&sz=18&dirflg=w&sll=44.972954,-93.274725&sspn=0.002273,0.004705&ie=UTF8&ll=44.972681,-93.274811&spn=0.002273,0.004705&z=18

Cheers,
Bryan

---

From: Gorry Fairhurst <[email-masked]>
Date: Fri, 21 Nov 2008 07:43:48 -0600

Bryan Ford wrote:
>>>> encapsulations for various transports, congestion control 
>>>> fairness/TCP-friendliness/segmentation/aggregation, etc. - try to 
>>>> meet for an informal "proto-BOF" and continue discussing these 
>>>> issues and how we might move forward.  For starters, maybe those of 
>>>> us available can meet up just outside the main meeting room sometime